<?php

if (!defined('FORUM')) die();

if ($section == 'outboundlinks')
{
	if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'.php') )
		require $ext_info['path'].'/lang/'.$forum_user['language'].'.php';
	else
		require $ext_info['path'].'/lang/English.php';
	
	// Setup the form
	$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

	$query = array(
		'SELECT'	=> 'id',
		'FROM'		=> 'pan_external_links',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$num_links = $forum_db->num_rows($result);


	//Page Navigation
	$forum_page['num_pages'] = ceil($num_links / $forum_user['disp_topics']);
	$forum_page['page'] = (!isset($_GET['p']) || !is_numeric($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $forum_page['num_pages']) ? 1 : $_GET['p'];
	$forum_page['start_from'] = $forum_user['disp_topics'] * ($forum_page['page'] - 1);
		$forum_page['finish_at'] = min(($forum_page['start_from'] + $forum_user['disp_topics']), ($num_links));
	$forum_page['items_info'] = generate_items_info($lang_pan_external_links['links_out'], ($forum_page['start_from'] + 1), $num_links);

	if($forum_page['num_pages'] > 1)
		$forum_page['paging_links'] = '<p class="paging"><span class="pages">'.$lang_pan_external_links['pages'].'</span> '.paginate($forum_page['num_pages'], $forum_page['page'], $forum_url['pan_external_links_settings'], $lang_common['Paging separator'], '', 1).'</p>';

	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array($lang_admin_common['Management'], forum_link($forum_url['admin_reports'])),
		$lang_pan_external_links['settings']
	);

	($hook = get_hook('pan_external_links_aop_maintenance_pre_header_load')) ? eval($hook) : null;

	define('FORUM_PAGE_SECTION', 'management');
	define('FORUM_PAGE', 'admin-pan-external-links');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

	($hook = get_hook('pan_external_links_aop_maintenance_output_start')) ? eval($hook) : null;

?>
	<div class="main-subhead">
		<h2 class="hn"><span><?php echo $lang_pan_external_links['links_head'] ?></span></h2>
	</div>
	
	<div class="main-content main-frm">
		
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_external_links_settings']) ?>">
			
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_external_links_settings'])) ?>" />
				<input type="hidden" name="form_sent" value="1" />
			</div>
			
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<legend class="group-legend"><strong><?php echo $lang_pan_external_links['links_head'] ?></strong></legend>

				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box checkbox">
						<input type="hidden" name="form[pan_external_links_out]" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="form[pan_external_links_out]" value="1"<?php if ($forum_config['o_pan_external_links_out'] == '1') echo ' checked="checked"' ?> /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>"><span><?php echo $lang_pan_external_links['links_out'] ?></span><?php echo $lang_pan_external_links['links_out_des'] ?></label>
					</div>
				</div>

				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box checkbox">
						<input type="hidden" name="form[pan_external_links_internal]" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="form[pan_external_links_internal]" value="1"<?php if ($forum_config['o_pan_external_links_internal'] == '1') echo ' checked="checked"' ?> /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>"><span><?php echo $lang_pan_external_links['links_internal'] ?></span><?php echo $lang_pan_external_links['links_internal_desc'] ?></label>
					</div>
				</div>

				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box checkbox">
						<input type="hidden" name="form[pan_external_links_blank]" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="form[pan_external_links_blank]" value="1"<?php if ($forum_config['o_pan_external_links_blank'] == '1') echo ' checked="checked"' ?> /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>"><span><?php echo $lang_pan_external_links['links_blank'] ?></span><?php echo $lang_pan_external_links['links_blank_desc'] ?></label>
					</div>
				</div>

<?php ($hook = get_hook('pan_external_links_aop_maintenance_pre_maintenance_message')) ? eval($hook) : null; ?>
				<div class="txt-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="txt-box textarea">
						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_pan_external_links['links_exception'] ?></span><small><?php echo $lang_pan_external_links['links_exception_desc'] ?></small></label>
						<div class="txt-input"><span class="fld-input"><textarea id="fld<?php echo $forum_page['fld_count'] ?>" name="form[pan_external_links_exception]" rows="5" cols="55"><?php echo forum_htmlencode($forum_config['o_pan_external_links_exception']) ?></textarea></span></div>
					</div>
				</div>
<?php ($hook = get_hook('pan_external_links_aop_maintenance_pre_maintenance_fieldset_end')) ? eval($hook) : null; ?>
			</fieldset>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="save" value="<?php echo $lang_pan_external_links['save_form'] ?>" /></span>
			</div>
		</form>
		
	</div>
	
	
	<div class="main-subhead">
		<h2 class="hn"><span><?php echo $lang_pan_external_links['list_links'] ?></span></h2>
	</div>
<?php

	$query = array(
		'SELECT'	=> 'e.сlicked, e.link, e.post_id, e.user_id, e.types, t.subject',
		'FROM'		=> 'pan_external_links AS e',
		
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'posts AS p',
				'ON'			=> 'p.id=e.post_id'
			),
			array(
				'LEFT JOIN'		=> 'topics AS t',
				'ON'			=> 't.id=p.topic_id'
			),
		),
		
//		'WHERE'		=> 'file_type=\'file\'',
		'ORDER BY'	=> 'e.id DESC',
		'LIMIT'		=> $forum_page['start_from'].', '.$forum_user['disp_topics']
	);
	($hook = get_hook('pan_external_links_get_links_info')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	if ($num_links > 0)
	{
?>

	<div id="brd-pagepost-top" class="main-pagepost gen-content">
		<?php echo $forum_page['paging_links'] ?>
	</div>

	<div class="main-content main-frm">
	
		<div id="brd-userlist">
		
			<table>
				<thead>
					<tr>
						<th class="tc0" style="width:40%;"><?php echo $lang_pan_external_links['link_from'] ?></th>
						<th class="tc1" style="width:50%;"><?php echo $lang_pan_external_links['link_to'] ?></th>
						<th class="tc2" style="width:10%;"><?php echo $lang_pan_external_links['link_coun'] ?></th>
					</tr>
				</thead>
				
				<tbody>
<?php

		while ($link_info = $forum_db->fetch_assoc($result))
		{
?>
			<form action="<?php echo forum_link($forum_url['pan_uploader_files']) ?>" accept-charset="utf-8" method="post" class="frm-form">
				<tr>
					<td class="tc0"><a href="<?php echo forum_link($forum_url['post'], $link_info['post_id']) ?>" target="_blank"><?php echo $link_info['subject'] ?></a></td>
					<td class="tc1"><a href="<?php echo forum_link($link_info['link']) ?>" target="_blank"><?php echo $link_info['link'] ?></a></td>
					<td class="tc2"><?php echo $link_info['сlicked'] ?></td>
				</tr>
			</form>
<?php
		}
?>

				</tbody>
			</table>
		</div>
	</div>
	
<?php
	} else {
?> 
	<div class="main-content main-frm">
		<div class="ct-box warn-box">
			<p><?php echo $lang_pan_external_links['link_not_links'] ?></p>
		</div>
	</div>
	
<?php
	}
}
