<?php 
/**
 * @author http://panbb.ru
 * @copyright (C) 2015 PanBB license GPL
 * @package pan_framework
 */
 
 function pan_add_one_view( $table_name, $field_name, $id = 0 )
{
	global $forum_db;
	
	if ($forum_db->table_exists($table_name) && $id > 0 ) {
		if ($forum_db->field_exists($table_name, $field_name) && $id > 0 ) {
			$query = array(
				'UPDATE'	=> ''.$table_name,
				'SET'		=> ''.$field_name.'='.$field_name.'+1',
				'WHERE'		=> 'id='.$id,
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
	}
}
 
//получить список директорий
function pan_get_all_dirs( $relative_path )
{
	$arr_dirs = array();
	if ($handle = opendir($relative_path) )
	{
		while (false !== ($dirname = readdir($handle) ) )
		{
			$dirname = $relative_path.'/'.$dirname;
			$tempname = basename($dirname);

			if (is_dir($dirname) && ($tempname != '.') && ($tempname != '..'))
				$arr_dirs[] = $tempname;
		}
		closedir($handle);
	}
	return $arr_dirs;
}

//получить массив файлов из директории
function pan_get_all_files( $relative_path, $allowable = '')
{
	$arr_files = array();
	if (is_dir($relative_path) ) {
		if ($dh = opendir($relative_path) ) {
			while (($file = readdir($dh) ) !== false) {
				$file_info = pathinfo($file);
				if (in_array($file_info['extension'], $allowable)) {
					$arr_files[] = $file;
				}
			}
			closedir($dh);
		}
	}
	return $arr_files;
}

//обновить настройки
function pan_update_options( $form )
{
	global $forum_db, $forum_config;
	
	foreach ($form as $key => $input)
	{
		// Only update option values that have changed
		if (array_key_exists('o_'.$key, $forum_config) && $forum_config['o_'.$key] != $input)
		{
			if ($input != '' || is_int($input))
				$value = '\''.$forum_db->escape($input).'\'';
			else
				$value = 'NULL';

			$query = array(
				'UPDATE'	=> 'config',
				'SET'		=> 'conf_value='.$value,
				'WHERE'		=> 'conf_name=\'o_'.$forum_db->escape($key).'\''
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
			// Regenerate the config cache
			if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
				require FORUM_ROOT.'include/cache.php';

				generate_config_cache();

			// If changed sef - remove quick-jump cache
			if (!empty($forum_config['o_sef']) && !empty($form['sef']))
			{
				if ($forum_config['o_sef'] != $form['sef'])
				{
					clean_quickjump_cache();
				}
			}
		}
	}
}

//Created 03/02/2017
function pan_fw_nouns_after_num($count, $form1='', $form2='', $form3='')
{
	global $forum_user;
	
	$binary = abs($count) % 100;
	$single = $count % 10;
	
	if ($forum_user['language'] == 'Russian')
	{
		if ($binary >= 11 && $binary <= 19) 
			return($form3);
		if ($single >= 2 && $single <= 4)
			return($form2);
		if ($single == 1)
			return($form1);
		
		($hook = get_hook('pan_fw_fn_nouns_after_num_new_lang')) ? eval($hook) : null;
		
	} else {
		if ($count == 1)
			return($form1);
		else
			return($form2);
	}
	
	return $form3;
}



