<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../../');
	
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if (!$forum_user['is_admmod'])
	message($lang_common['No permission']);

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (file_exists(FORUM_ROOT.'extensions/pan_moderator/lang/'.$forum_user['language'].'/pan_moderator.php') )
	require FORUM_ROOT.'extensions/pan_moderator/lang/'.$forum_user['language'].'/pan_moderator.php';
else
	require FORUM_ROOT.'extensions/pan_moderator/lang/English/pan_moderator.php';

if (isset($_POST['update_config']))
{
	$form = array_map('trim', $_POST['form']);

	foreach ($form as $key => $input)
	{
		// Only update option values that have changed
		if (array_key_exists('o_'.$key, $forum_config) && $forum_config['o_'.$key] != $input)
		{
			if ($input != '' || is_int($input))
				$value = '\''.$forum_db->escape($input).'\'';
			else
				$value = 'NULL';

			$query = array(
					'UPDATE'	=> 'config',
					'SET'		=> 'conf_value='.$value,
					'WHERE'		=> 'conf_name=\'o_'.$forum_db->escape($key).'\''
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				
				// Regenerate the config cache
				if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
					require FORUM_ROOT.'include/cache.php';

				generate_config_cache();

				// If changed sef - remove quick-jump cache
				if (!empty($forum_config['o_sef']) && !empty($form['sef']))
				{
					if ($forum_config['o_sef'] != $form['sef'])
					{
						clean_quickjump_cache();
					}
				}
			}
		}
	
	$forum_flash->add_info($lang_pan_moderator['settings_updated']);
	redirect(forum_link($forum_url['pan_moderator_config']), $lang_pan_moderator['settings_updated']);
}
	
$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
//		array($lang_admin_common['Settings'], forum_link($forum_url['admin_settings_setup'])),
	'Moderator'
);

$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

define('FORUM_PAGE_SECTION', 'management');
define('FORUM_PAGE', 'admin-pan-moderator-config');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>

	<div class="main-subhead">
		<h2 class="hn"><span><?php echo $lang_pan_moderator['mod_config'] ?></span></h2>
	</div>
	
	<div class="main-content main-frm">
	
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_moderator_config']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_moderator_config'])) ?>" />
			</div>


			<div class="content-head">
				<h2 class="hn"><span><?php echo $lang_pan_moderator['auto_mod'] ?></span></h2>
			</div>
			
			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_moderator['interval'] ?></span><small><?php echo $lang_pan_moderator['interval_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" id="fld " name="form[pan_moderator_interval]" size="5" maxlength="3" value="<?php echo forum_htmlencode($forum_config['o_pan_moderator_interval']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_moderator['topics_close'] ?></span><small><?php echo $lang_pan_moderator['topics_close_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" id="fld " name="form[pan_moderator_topics_close]" size="5" maxlength="5" value="<?php echo forum_htmlencode($forum_config['o_pan_moderator_topics_close']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_moderator['topics_delete'] ?></span><small><?php echo $lang_pan_moderator['topics_delete_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" id="fld " name="form[pan_moderator_topics_delete]" size="5" maxlength="5" value="<?php echo forum_htmlencode($forum_config['o_pan_moderator_topics_delete']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box select">
					<label for="fld<?php echo ++$forum_page['fld_count'] ?>">
						<span><?php echo $lang_pan_moderator['external_links'] ?></span>
						<small><?php echo $lang_pan_moderator['external_links_i'] ?></small>
					</label><br />
					<span class="fld-input"><select id="fld<?php echo $forum_page['fld_count'] ?>" name="form[pan_moderator_checking_links_mode]">
<?php

$o_pan_moderator_topics_action = array(
	'0' => $lang_pan_moderator['disabled'],
	'1' => $lang_pan_moderator['send_for_review'],
	'2' => $lang_pan_moderator['cleaned_and_activated'],
);

foreach ($o_pan_moderator_topics_action as $key => $val)
{
	if ($forum_config['o_pan_moderator_checking_links_mode'] == $key)
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$key.'" selected="selected">'.$val.'</option>'."\n";
	else
		echo "\t\t\t\t\t\t\t\t".'<option value="'.$key.'">'.$val.'</option>'."\n";
}

?>
					</select></span>
				</div>
			</div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="update_config" value="<?php echo $lang_pan_moderator['update_config'] ?>" /></span>
			</div>

		</form>

		<div id="info-censored-intro" class="ct-box">
			<p>More info on <a href="http://panbb.ru/forum/" target="_blank">PanBB.ru</a></p>
		</div>
		
	</div>
<?php

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';
