<?php 
/**
 * @author http://panbb.ru
 * @copyright (C) 2015 PanBB license GPL
 * @package pan_moderator
 */
 
function PanModeratorGetInactive()
{
	global $forum_db;

	$query = array(
		'SELECT'	=> 'p.id',
		'FROM'		=> 'posts AS p',
		'WHERE'		=> 'p.topic_id=0'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	return $num_inactive = $forum_db->num_rows($result);
}

function PanModeratorGetOutLinks($content) 
{
	global $base_url;

	$patern = '/(https?:\/\/)?(www\.)?([-а-яa-zёЁцушщхъфырэчстью0-9_\.]{2,}\.)(рф|[a-z]{2,6})((\/[-а-яёЁцушщхъфырэчстьюa-z0-9_]{1,})?\/?([a-z0-9_-]{2,}\.[a-z]{2,6})?(\?[a-z0-9_]{2,}=[-0-9]{1,})?((\&[a-z0-9_]{2,}=[-0-9]{1,}){1,})?)/i';

	preg_match_all($patern, $content, $matches);

	$output = array();
	for ($i = 0; $i < count($matches); $i++) {
		if (!empty($matches[0][$i]) && (stristr($matches[0][$i], $base_url) === false))
			$output[] = $matches[0][$i];
	}

	if (!empty($output))
		return $output; 
}

function pan_moderator_clear_links_msg($content)
{
	global $base_url;

	$patern = '/(https?:\/\/)?(www\.)?([-а-яa-zёЁцушщхъфырэчстью0-9_\.]{2,}\.)(рф|[a-z]{2,6})((\/[-а-яёЁцушщхъфырэчстьюa-z0-9_]{1,})?\/?([a-z0-9_-]{2,}\.[a-z]{2,6})?(\?[a-z0-9_]{2,}=[-0-9]{1,})?((\&[a-z0-9_]{2,}=[-0-9]{1,}){1,})?)/i';

	preg_match_all($patern, $content, $matches);

	for ($i = 0; $i < count($matches); $i++)
	{
		if (!empty($matches[0][$i]) && (stristr($matches[0][$i], $base_url) === false) )
		{
			$content = str_ireplace($matches[0][$i], '', $content);
		}
	}

	return $content;
}

function pan_moderator_send_email()
{
	global $forum_db, $forum_url, $forum_user, $forum_config, $lang_common;

	$online_info = array();
	$query = array(
		'SELECT'	=> 'user_id',
		'FROM'		=> 'online',
		'WHERE'		=> 'idle=0 AND user_id > 1'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($fetch_online = $forum_db->fetch_assoc($result))
		$online_info[$fetch_online['user_id']] = $fetch_online['user_id'];

	$query = array(
		'SELECT'	=> 'id, email, language',
		'FROM'		=> 'users',
		'WHERE'		=> 'pan_mod_email=1'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	while ($user_info = $forum_db->fetch_assoc($result))
	{
		if (!isset($online_info[$user_info['id']]) )
		{
			if (file_exists($forum_url['pan_moderator_path'].'/lang/'.$user_info['language'].'/mail_template/unverified_msg.tpl'))
				$mail_tpl = forum_trim(file_get_contents($forum_url['pan_moderator_path'].'/lang/'.$user_info['language'].'/mail_template/unverified_msg.tpl'));
			else
				$mail_tpl = forum_trim(file_get_contents($forum_url['pan_moderator_path'].'/lang/English/mail_template/unverified_msg.tpl'));
			
			// The first row contains the subject
			$first_crlf = strpos($mail_tpl, "\n");
			$mail_subject = forum_trim(substr($mail_tpl, 8, $first_crlf-8));
			$mail_message = forum_trim(substr($mail_tpl, $first_crlf));
			
			$mail_subject = str_replace('<username>', $forum_user['username'], $mail_subject);
			$mail_message = str_replace('<board_title>', $forum_config['o_board_title'], $mail_message);
			$mail_message = str_replace('<base_url>', forum_link($forum_url['pan_moderator_list_inactive']), $mail_message);
			
			$mail_message = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $forum_config['o_board_title']), $mail_message);
			
			if (!defined('FORUM_EMAIL_FUNCTIONS_LOADED'))
				require FORUM_ROOT.'include/email.php';
			
			forum_mail(forum_htmlencode($user_info['email']), $mail_subject, $mail_message);
		}
	}
}

// Send out emails
function pan_moderator_send_email_any($post_info, $new_pid)
{
	global $forum_db, $forum_url, $forum_user, $forum_config, $lang_common;

	$online_info = array();
	$query = array(
		'SELECT'	=> 'user_id',
		'FROM'		=> 'online',
		'WHERE'		=> 'idle=0 AND user_id > 1'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($fetch_online = $forum_db->fetch_assoc($result))
		$online_info[$fetch_online['user_id']] = $fetch_online['user_id'];

	$query = array(
		'SELECT'	=> 'id, email, language',
		'FROM'		=> 'users',
		'WHERE'		=> 'pan_mod_email=2'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	while ($user_info = $forum_db->fetch_assoc($result))
	{
		if (!isset($online_info[$user_info['id']]) )
		{
			if (file_exists($forum_url['pan_moderator_path'].'/lang/'.$user_info['language'].'/mail_template/any_msg.tpl'))
				$mail_tpl = forum_trim(file_get_contents($forum_url['pan_moderator_path'].'/lang/'.$user_info['language'].'/mail_template/any_msg.tpl'));
			else
				$mail_tpl = forum_trim(file_get_contents($forum_url['pan_moderator_path'].'/lang/English/mail_template/any_msg.tpl'));
			
			// The first row contains the subject
			$first_crlf = strpos($mail_tpl, "\n");
			$mail_subject = forum_trim(substr($mail_tpl, 8, $first_crlf-8));
			$mail_message = forum_trim(substr($mail_tpl, $first_crlf));
			
			$mail_subject = str_replace('<username>', $forum_user['username'], $mail_subject);
			$mail_message = str_replace('<board_title>', $forum_config['o_board_title'], $mail_message);
			$mail_message = str_replace('<base_url>', forum_link($forum_url['post'], $new_pid), $mail_message);
			
			$mail_message = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $forum_config['o_board_title']), $mail_message);
			
			if (!defined('FORUM_EMAIL_FUNCTIONS_LOADED'))
				require FORUM_ROOT.'include/email.php';
			
			forum_mail(forum_htmlencode($user_info['email']), $mail_subject, $mail_message);
		}
	}
}

// Creates a new post
function pan_moderator_add_post($new_pid)
{
	global $forum_db, $db_type, $forum_config, $lang_common;
	
	$query = array(
		'SELECT'	=> 'f.id AS fid, f.forum_name, f.moderators, f.redirect_url, t.id AS tid, t.subject, t.first_post_id, t.closed, t.forum_id, p.poster, p.poster_id, p.poster_email, p.message, p.hide_smilies, p.posted, p.topic_id',
		'FROM'		=> 'posts AS p',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'topics AS t',
				'ON'			=> 't.id=p.topic_id'
			),
			array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'f.id=t.forum_id'
			),
		),
		'WHERE'		=> 'p.id='.$new_pid
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$cur_post = $forum_db->fetch_assoc($result);

	$post_info = array(
		'is_guest'		=> ($cur_post['poster_id'] == 1) ? $cur_post['poster'] : '',
		'poster'		=> $cur_post['poster'],
		'poster_id'		=> $cur_post['poster_id'],
		'poster_email'	=> (($cur_post['poster_id'] == 1) && $cur_post['poster_email'] != '') ? $cur_post['poster_email'] : null,
		'subject'		=> $cur_post['subject'],
		'message'		=> $cur_post['message'],
		'hide_smilies'	=> $cur_post['hide_smilies'],
		'posted'		=> $cur_post['posted'],
		'subscr_action'	=> 0,
		'topic_id'		=> $cur_post['topic_id'],
		'forum_id'		=> $cur_post['forum_id'],
		'update_user'	=> true,
		'update_unread'	=> true
	);

	// Count number of replies in the topic
	$query = array(
		'SELECT'	=> 'COUNT(p.id)',
		'FROM'		=> 'posts AS p',
		'WHERE'		=> 'p.topic_id='.$post_info['topic_id']
	);

	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	$num_replies = $forum_db->result($result, 0) - 1;

	// Update topic
	$query = array(
		'UPDATE'	=> 'topics',
		'SET'		=> 'num_replies='.$num_replies.', last_post='.$post_info['posted'].', last_post_id='.$new_pid.', last_poster=\''.$forum_db->escape($post_info['poster']).'\'',
		'WHERE'		=> 'id='.$post_info['topic_id']
	);

	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	sync_forum($post_info['forum_id']);

	if (!defined('FORUM_SEARCH_IDX_FUNCTIONS_LOADED'))
		require FORUM_ROOT.'include/search_idx.php';

	update_search_index('post', $new_pid, $post_info['message']);

	send_subscriptions($post_info, $new_pid);

	// Increment user's post count & last post time
	if (isset($post_info['update_user']))
	{
		if ($post_info['is_guest'])
		{
			$query = array(
				'UPDATE'	=> 'online',
				'SET'		=> 'last_post='.$post_info['posted'],
				'WHERE'		=> 'ident=\''.$forum_db->escape(get_remote_address()).'\''
			);
		}
		else
		{
			$query = array(
				'UPDATE'	=> 'users',
				'SET'		=> 'num_posts=num_posts+1, last_post='.$post_info['posted'],
				'WHERE'		=> 'id='.$post_info['poster_id']
			);
		}

		$forum_db->query_build($query) or error(__FILE__, __LINE__);
	}

	// If the posting user is logged in update his/her unread indicator
	if (!$post_info['is_guest'] && isset($post_info['update_unread']) && $post_info['update_unread'])
	{
		$tracked_topics = get_tracked_topics();
		$tracked_topics['topics'][$post_info['topic_id']] = time();
		set_tracked_topics($tracked_topics);
	}

}

function pan_moderator_prune_old_topic()
{
	global $forum_db, $forum_config;
	
	if ($forum_config['o_pan_moderator_interval'] > 0)
	{
		$prune_date = ($forum_config['o_pan_moderator_topics_delete'] > 0) ? time() - ($forum_config['o_pan_moderator_topics_delete']*86400) : 0;

		($hook = get_hook('pan_moderator_fn_prune_old_topic_start')) ? eval($hook) : null;

		@set_time_limit(0);

		if ($prune_date > 0)
		{
			$query = array(
				'SELECT'	=> 'f.id',
				'FROM'		=> 'forums AS f'
			);
			($hook = get_hook('pan_moderator_fn_prune_old_topic_comply_qr_get_all_forums')) ? eval($hook) : null;
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

			while ($cur_forum = $forum_db->fetch_assoc($result)) {
				pan_prune($cur_forum['id'], 0, $prune_date);
				sync_forum($cur_forum['id']);
			}

			delete_orphans();
			
			$query = array(
				'UPDATE'	=> 'config',
				'SET'		=> 'conf_value='.time(),
				'WHERE'		=> 'conf_name=\'o_pan_moderator_last_date\''
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
		}
	}
}

function pan_prune($forum_id, $prune_sticky, $prune_date)
{
	global $forum_db, $db_type;

	$return = ($hook = get_hook('pan_moderator_fn_pan_prune_start')) ? eval($hook) : null;
	if ($return != null)
		return;

	// Fetch topics to prune
	$query = array(
		'SELECT'	=> 't.id',
		'FROM'		=> 'topics AS t',
		'WHERE'		=> 't.forum_id='.$forum_id
	);

	if ($prune_date > 0)
		$query['WHERE'] .= ' AND last_post<'.$prune_date;
	if ($prune_sticky == 1)
		$query['WHERE'] .= ' AND sticky=\'0\'';

	($hook = get_hook('pan_moderator_fn_pan_prune_qr_get_topics_to_prune')) ? eval($hook) : null;
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	$topic_ids = array();
	while ($row = $forum_db->fetch_row($result))
		$topic_ids[] = $row[0];

	if (!empty($topic_ids))
	{
		$topic_ids = implode(',', $topic_ids);

		// Fetch posts to prune (used lated for updating the search index)
		$query = array(
			'SELECT'	=> 'p.id',
			'FROM'		=> 'posts AS p',
			'WHERE'		=> 'p.topic_id IN('.$topic_ids.')'
		);

		($hook = get_hook('pan_moderator_fn_pan_prune_qr_get_posts_to_prune')) ? eval($hook) : null;
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

		$post_ids = array();
		while ($row = $forum_db->fetch_row($result))
			$post_ids[] = $row[0];

		// Delete topics
		$query = array(
			'DELETE'	=> 'topics',
			'WHERE'		=> 'id IN('.$topic_ids.')'
		);

		($hook = get_hook('pan_moderator_fn_pan_prune_qr_prune_topics')) ? eval($hook) : null;
		$forum_db->query_build($query) or error(__FILE__, __LINE__);

		// Delete posts
		$query = array(
			'DELETE'	=> 'posts',
			'WHERE'		=> 'topic_id IN('.$topic_ids.')'
		);

		($hook = get_hook('pan_moderator_fn_pan_prune_qr_prune_posts')) ? eval($hook) : null;
		$forum_db->query_build($query) or error(__FILE__, __LINE__);

		// Delete subscriptions
		$query = array(
			'DELETE'	=> 'subscriptions',
			'WHERE'		=> 'topic_id IN('.$topic_ids.')'
		);

		($hook = get_hook('pan_moderator_fn_pan_prune_qr_prune_subscriptions')) ? eval($hook) : null;
		$forum_db->query_build($query) or error(__FILE__, __LINE__);

		// We removed a bunch of posts, so now we have to update the search index
		if (!defined('FORUM_SEARCH_IDX_FUNCTIONS_LOADED'))
			require_once FORUM_ROOT.'include/search_idx.php';

		strip_search_index($post_ids);
	}
}

function pan_moderator_close_old_topic()
{
	global $forum_db, $db_type, $forum_config;
	
	$max_time = time() - ($forum_config['o_pan_moderator_topics_close']*86400);
	
	$query = array(
		'UPDATE'	=> 'topics',
		'SET'		=> 'closed=1',
		'WHERE'		=> 'posted<'.$max_time
	);
	$forum_db->query_build($query) or error(__FILE__, __LINE__);
	
}


