<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');
	
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

($hook = get_hook('pan_preview_image_settings_start')) ? eval($hook) : null;

require FORUM_ROOT.'extensions/pan_uploader/resizeimage.php';

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (file_exists(FORUM_ROOT.'extensions/pan_uploader/lang/'.$forum_user['language'].'/pan_uploader.php'))
	require FORUM_ROOT.'extensions/pan_uploader/lang/'.$forum_user['language'].'/pan_uploader.php';
else
	require FORUM_ROOT.'extensions/pan_uploader/lang/English/pan_uploader.php';

if (file_exists(FORUM_ROOT.'extensions/pan_preview_image/lang/'.$forum_user['language'].'.php'))
	require FORUM_ROOT.'extensions/pan_preview_image/lang/'.$forum_user['language'].'.php';
else
	require FORUM_ROOT.'extensions/pan_preview_image/lang/English.php';

$posts_info = array();
$posts_img_links = array();
$external_img_links = array();
$pattern_img = '#\[img\](.*?)\[/img\]#i';

$query = array(
	'SELECT'	=> 'message',
	'FROM'		=> 'posts',
	'WHERE'		=> 'message '.($db_type == 'pgsql' ? 'ILIKE' : 'LIKE').' \''.$forum_db->escape('%[img]%').'\''
);
($hook = get_hook('pan_preview_image_settings_db_sel_posts_search_img')) ? eval($hook) : null;
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($rows = $forum_db->fetch_assoc($result))
{
	$posts_info[] = $rows['message'];
	preg_match_all($pattern_img, $rows['message'], $arr_img);
	
	if (isset($arr_img[1]))
	{
		foreach ($arr_img[1] as $key => $val)
		{
			$posts_img_links[] = $val;
			
			if (stristr($val, $base_url) === false)
				$external_img_links[] = $val;
		}
	}
}


$uploader_info = array();
$query = array(
	'SELECT'	=> 'file_url',
	'FROM'		=> 'uploaded_files',
	'WHERE'		=> 'file_type=\'image\'',
);
($hook = get_hook('pan_preview_image_settings_db_get_type_img')) ? eval($hook) : null;
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($rows = $forum_db->fetch_assoc($result))
	$uploader_info[] = $rows['file_url'];

if (isset($_POST['create_preview']))
{
	foreach ($uploader_info as $key => $url)
	{
		$img_name = basename($url);
		$path_previews = str_replace('/images/', '/previews/', $url);
		$dir_path = dirname($path_previews);
		$arr_dirs = explode('/', $dir_path);
		
		if (!file_exists(FORUM_ROOT . $path_previews))
		{
			$i=0;
			foreach ($arr_dirs as $key => $dir)
			{
				if (!empty($dir))
				{
					if ($i == 0)
						$full_path = $dir.'/';
					else
						$full_path = $full_path . $dir.'/';
					
					if (!is_dir(FORUM_ROOT.$full_path)) {
						@mkdir(FORUM_ROOT.$full_path);
						@chmod(FORUM_ROOT.$full_path, 0777);
					}
					$i++;
				}
			}
			
			$new_path_preview = FORUM_ROOT.$path_previews;
			if (file_exists(FORUM_ROOT.$url))
			{
				copy(FORUM_ROOT.$url, $new_path_preview);
				
				list($width, $height) = getimagesize($new_path_preview);
				if ($height > $forum_config['o_pan_preview_image_height'] || $width > $forum_config['o_pan_preview_image_width'])
				{
					try
					{
						$resize = new \Eventviva\ImageResize($new_path_preview);
						$resize->resizeToBestFit($forum_config['o_pan_preview_image_width'], $forum_config['o_pan_preview_image_height']);
						//resize, resizeToHeight, resizeToWidth, resizeToBestFit;
						$resize->save($new_path_preview, null, 80); //80 = image quality;
						$image_size = filesize($new_path_preview);
					}
					catch(Exception $e)
					{
						//
					}
				}
			}
		}
	}
	
	$forum_flash->add_info($lang_pan_preview_image['created_preview']);
	redirect(forum_link($forum_url['pan_preview_image']), $lang_pan_preview_image['created_preview']);
}


if (isset($_POST['save']))
{
	$form = array_map('trim', $_POST['form']);
	($hook = get_hook('pan_preview_image_settings_save_config')) ? eval($hook) : null;
	pan_update_options($form);
	
	$forum_flash->add_info($lang_pan_preview_image['settings_updated']);
	redirect(forum_link($forum_url['pan_preview_image']), $lang_pan_preview_image['settings_updated']);
}


$forum_page['crumbs'] = array(
	array($forum_config['o_board_title'], forum_link($forum_url['index'])),
	array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
	array($lang_pan_uploader['Uploader'], forum_link($forum_url['pan_uploader'])),
	$lang_pan_preview_image['miniatures']
);

$forum_page['item_count'] = $forum_page['fld_count'] = 0;

define('FORUM_PAGE_SECTION', 'pan_uploader');
define('FORUM_PAGE', 'admin-pan-preview-image');
require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

?>

	<div class="main-subhead">
		<h2 class="hn"><span><?php echo $lang_pan_preview_image['options_header'] ?></span></h2>
	</div>

	<div class="main-content main-frm">

		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_preview_image']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_preview_image'])) ?>" />
			</div>

			<div class="ct-box warn-box">
				<p><?php echo $lang_pan_preview_image['config_info'] ?></p>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_preview_image['preview_width'] ?></span><small><?php echo $lang_pan_preview_image['preview_width_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[pan_preview_image_width]" size="10" maxlength="4" value="<?php echo forum_htmlencode($forum_config['o_pan_preview_image_width']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_preview_image['preview_height'] ?></span><small><?php echo $lang_pan_preview_image['preview_height_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[pan_preview_image_height]" size="10" maxlength="4" value="<?php echo forum_htmlencode($forum_config['o_pan_preview_image_height']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_preview_image['quality'] ?></span><small><?php echo $lang_pan_preview_image['quality_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[pan_preview_image_quality]" size="10" maxlength="2" value="<?php echo forum_htmlencode($forum_config['o_pan_preview_image_quality']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
				<div class="sf-box checkbox">
					<input type="hidden" name="form[pan_preview_image_external]" value="0" />
					<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="form[pan_preview_image_external]" value="1"<?php if ($forum_config['o_pan_preview_image_external'] == '1') echo ' checked="checked"' ?> /></span>
					<label for="fld<?php echo $forum_page['fld_count'] ?>"><span><?php echo $lang_pan_preview_image['preview_external'] ?></span><?php echo $lang_pan_preview_image['preview_external_i'] ?></label>
				</div>
			</div>

<?php ($hook = get_hook('pan_preview_image_settings_pre_submit')) ? eval($hook) : null; ?>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="save" value="<?php echo $lang_pan_preview_image['save'] ?>" /></span>
			</div>

		</form>
		
		<div class="content-head">
			<h2 class="hn"><span><?php echo $lang_pan_preview_image['statistic'] ?></span></h2>
		</div>
		
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_preview_image']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_preview_image'])) ?>" />
			</div>


			<div class="ct-box warn-box">
				<p><?php printf($lang_pan_preview_image['stat_search_msg'], count($posts_info)) ?></p>
				<p><?php printf($lang_pan_preview_image['stat_search_img'], count($posts_img_links)) ?></p>
				<p><?php printf($lang_pan_preview_image['stat_search_upload'], count($uploader_info)) ?></p>
				<p><?php printf($lang_pan_preview_image['stat_search_external'], count($external_img_links)) ?></p>
			</div>


			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="create_preview" value="<?php echo $lang_pan_preview_image['create_preview'] ?>" /></span>
			</div>

		</form>
		
	</div>


<?php

($hook = get_hook('pan_preview_image_settings_end')) ? eval($hook) : null;

$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';