<?php

if (!defined('FORUM_ROOT'))
	define('FORUM_ROOT', '../../');
	
require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'include/common_admin.php';

if ($forum_user['g_id'] != FORUM_ADMIN)
	message($lang_common['No permission']);

// Load the admin.php language files
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_common.php';
require FORUM_ROOT.'lang/'.$forum_user['language'].'/admin_index.php';

if (file_exists(FORUM_ROOT.'extensions/pan_statistic/lang/'.$forum_user['language'].'/admin_pan_statistic.php'))
	require FORUM_ROOT.'extensions/pan_statistic/lang/'.$forum_user['language'].'/admin_pan_statistic.php';
else
	require FORUM_ROOT.'extensions/pan_statistic/lang/English/admin_pan_statistic.php';

if (isset($_POST['update_options'])) {
    $form = array_map('trim', $_POST['form']);
    
	foreach ($form as $key => $input) {
		// Only update option values that have changed
		if (array_key_exists('o_'.$key, $forum_config) && $forum_config['o_'.$key] != $input) {
			if ($input != '' || is_int($input))
				$value = '\''.$forum_db->escape($input).'\'';
			else
				$value = 'NULL';

			$query = array(
				'UPDATE'	=> 'config',
				'SET'		=> 'conf_value='.$value,
				'WHERE'		=> 'conf_name=\'o_'.$forum_db->escape($key).'\''
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			
	        // Regenerate the config cache
	        if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
	        	require FORUM_ROOT.'include/cache.php';

	            generate_config_cache();

	        // If changed sef - remove quick-jump cache
	        if (!empty($forum_config['o_sef']) && !empty($form['sef'])) {
	        	if ($forum_config['o_sef'] != $form['sef']) {
	        		clean_quickjump_cache();
	        	}
	        }
		}
	}
	
    $message = 'Настройки обновлены';
	$forum_flash->add_info($message);
	
    if($_SERVER['HTTP_REFERER']) {
        $pan_url_from = $_SERVER['HTTP_REFERER']; 
    }
    
	redirect($pan_url_from, $message);
}
	
$forum_page['crumbs'] = array(
        array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array('Статистика', forum_link($forum_url['pan_statistic']))
);

$section = '';
if ( isset($_GET['section']) )
	$section = $_GET['section'];

define('FORUM_PAGE_SECTION', 'statistic');

if ( $section == 'fool' ) {
    $forum_page['crumbs'][] = array('Month', forum_link($forum_url['pan_statistic_fool']) );
    define('FORUM_PAGE', 'admin-pan-statistic-fool');
} else if ( $section == 'user-agent' ) {
    $forum_page['crumbs'][] = array('User Agent', forum_link($forum_url['pan_statistic_user_agent']) );
    define('FORUM_PAGE', 'admin-pan-statistic-user-agent');
} else {
    $forum_page['crumbs'][] = array('Day', forum_link($forum_url['pan_statistic']) );
    define('FORUM_PAGE', 'admin-pan-statistic');
}

require FORUM_ROOT.'header.php';

// START SUBST - <!-- forum_main -->
ob_start();

if ( $section == "fool" ) { ?>

<div class="main-content main-frm">
	<div class="ct-group">
		<table>
			<thead>
				<tr>
					<th class="tc0" scope="col"><?php echo $admin_pan_statistic['Date'] ?></th>
					<th class="tc1" scope="col"><?php echo $admin_pan_statistic['Unique'] ?></th>
					<th class="tc2" scope="col"><?php echo $admin_pan_statistic['Views'] ?></th>
					<th class="tc3" scope="col"><?php echo $admin_pan_statistic['FixMaxOnline'] ?></th>
				</tr>
			</thead>
			<tbody>
<?php
		$query = array(
			'SELECT'	=> '*',
			'FROM'		=> 'pan_stat_visits'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$i = 1;
		while ( $pun_stat = $forum_db->fetch_assoc($result) )
		{
			echo '<tr class="'.(($i % 2 != 0) ? 'odd' : 'even').' '.(($i == 1) ? ' row1' : '').'">
					<td class="tc0">'.date('d-M  H:i:s', $pun_stat['v_time']).'</td>
					<td class="tc1">'.$pun_stat['hosts'].'</td>
					<td class="tc2">'.$pun_stat['views'].'</td>
					<td class="tc3">'.(($pun_stat['max_online']>0) ? $pun_stat['max_online'] : '').'</td>
				</tr>';

			$i++;
		}	
?>
			</tbody>
		</table>
	</div>
</div>
<?php } else if ( $section == "user-agent" ) { ?>
<div class="main-content main-frm">
	<div class="ct-group">
		<table>
			<thead>
				<tr>
				    <th class="tc0" scope="col" width="12%"><?php echo $admin_pan_statistic['Time In'] ?></th>
					<th class="tc0" scope="col" width="12%"><?php echo $admin_pan_statistic['User IP'] ?></th>
					<th class="tc0" scope="col" width="12%"><?php echo $admin_pan_statistic['User Name'] ?></th>
					<th class="tc1" scope="col"><?php echo $admin_pan_statistic['User Agent'] ?></th>
				</tr>
			</thead>
			<tbody>
<?php
		$query = array(
	               'SELECT'         => '*',
                   'FROM'           => 'pan_stat_ips',
                   'ORDER BY'       => 'time_logged ASC'
                );
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
                $i = 1;

		while ( $pun_stat = $forum_db->fetch_assoc($result) ) {
			echo '
			    <tr class="'.(($i % 2 != 0) ? 'odd' : 'even').' '.(($i == 1) ? ' row1' : '').'">
				    <td class="tc0">'.date('d-M  H:i:s', $pun_stat['time_logged']).'</td>
				    <td class="tc0">'.$pun_stat['ip_address'].'</td>
				    <td class="tc0">'.(($pun_stat['user_name'] != $pun_stat['ip_address']) ? $pun_stat['user_name'] : 'Guest').'</td>
				    <td class="tc0">'.$pun_stat['user_agent'].'</td>
				</tr>';
			$i++;
		}	
?>
		    </tbody>
		</table>
	</div>
</div>

<?php 
} else {
?>

<div class="main-content main-frm">
	<div class="ct-group">
		<table>
			<thead>
				<tr>
				    <th class="tc0" scope="col"><?php echo $admin_pan_statistic['Time In'] ?></th>
					<th class="tc0" scope="col"><?php echo $admin_pan_statistic['User IP'] ?></th>
					<th class="tc0" scope="col"><?php echo $admin_pan_statistic['User'] ?></th>
					<th class="tc1" scope="col"><?php echo $admin_pan_statistic['Site From'] ?></th>
					<th class="tc2" scope="col"><?php echo $admin_pan_statistic['URL To'] ?></th>
					<th class="tc2" scope="col"><?php echo $admin_pan_statistic['URL Out'] ?></th>
					<th class="tc2" scope="col"><?php echo $admin_pan_statistic['Time Out'] ?></th>
					<th class="tc2" scope="col"><?php echo $admin_pan_statistic['Time On Forum'] ?></th>
					<th class="tc2" scope="col" width="20px"><?php echo $admin_pan_statistic['Views'] ?></th>
				</tr>
        	</thead>
			<tbody>
<?php
		$query = array(
	        'SELECT'        => '*',
            'FROM'          => 'pan_stat_ips',
            'ORDER BY'      => 'time_logged'
        );
        

		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
                $i = 1;

		while ( $pun_stat = $forum_db->fetch_assoc($result) )
		{
		    
            $pun_stat_time_logout = $pun_stat['time_logout'];
            $pun_stat_time_logged = $pun_stat['time_logged'];
            $pun_stat_time_all = ($pun_stat_time_logout - $pun_stat_time_logged);
            $url_from = $pun_stat['url_from'];
?> 
			    <tr>
				<td class="tc2"><?php echo date('d-M  H:i:s', $pun_stat['time_logged']) ?></td>
                <td class="tc4"><a href="<?php echo $forum_config['o_pan_statistic_ip_geolocate'].$pun_stat['ip_address'] ?>" target="new_blank"><?php echo $pun_stat['ip_address']  ?></a></td>
                <td class="tc3"><?php echo (($pun_stat['user_name'] != $pun_stat['ip_address']) ? $pun_stat['user_name'] : 'Guest')  ?></td>
				<td class="tc5"><a href="http://<?php echo parse_url($url_from, PHP_URL_HOST) ?>" target="new_blank"><?php echo parse_url($url_from, PHP_URL_HOST) ?></a></td>
				<td class="tc6"><a href="<?php echo $pun_stat['url_where'] ?>" target="new_blank"><?php echo $pun_stat['url_where']  ?></a></td>
				<td class="tc7"><a href="<?php echo $pun_stat['url_logout'] ?>" target="new_blank"><?php echo $pun_stat['url_logout']  ?></a></td>
				<td class="tc8"><?php echo date('H:i:s', $pun_stat['time_logout']) ?></td>
				<td class="tc9"><?php echo gmdate('H:i:s', $pun_stat_time_all) ?></td>
				<td class="tc10"><?php echo $pun_stat['views_pages'] ?></td>
				</tr>
<?php 
		}	
?>
		    </tbody>
		</table>
	</div>
</div>
<?php
}
$tpl_temp = forum_trim(ob_get_contents());
$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
ob_end_clean();
// END SUBST - <!-- forum_main -->

require FORUM_ROOT.'footer.php';