<?php

function pan_uploader_uploads_list_files($folder, &$all_files)
{
	$fp = opendir ( $folder );
	
	while ( $cv_file = readdir ( $fp ) ) 
	{
		if ( is_file( $folder."/".$cv_file ) )
		{
			$all_files[] = $folder."/".$cv_file;
		} elseif ( $cv_file != "." && $cv_file != ".." && is_dir ( $folder."/".$cv_file ) ) {
			uploads_list_files( $folder."/".$cv_file, $all_files );
		}
	}
	closedir($fp);
}
 
function pan_uploader_file_structure($dir = 'files')
{
	global $forum_config, $forum_user;
	
	($hook = get_hook('pan_uploader_fn_file_structure_start')) ? eval($hook) : null;
	
	if ($forum_config['o_pan_uploader_file_structure'] == '1')
	{
		$dir_images = FORUM_ROOT.'/uploads/'.$dir.'/'.date('Y', time()).'/';
		
		if (!file_exists($dir_images) ) {
			@mkdir($dir_images);
			@chmod($dir_images, 0777);
		}
		
		if (!file_exists($dir_images.date('m', time()).'/') ) {
			@mkdir($dir_images.date('m', time()).'/');
			@chmod($dir_images.date('m', time()).'/', 0777);
		}
		
		$path_to_dir = date('Y', time()).'/'.date('m', time());
	}
	else if ($forum_config['o_pan_uploader_file_structure'] == '2')
	{
		$dir_images = FORUM_ROOT.'/uploads/'.$dir.'/'.$forum_user['id'].'/';
		
		if (!file_exists($dir_images) ) {
			@mkdir($dir_images);
			@chmod($dir_images, 0777);
		}
		
		$path_to_dir = $forum_user['id'];
	}
	
	($hook = get_hook('pan_uploader_fn_file_structure_end')) ? eval($hook) : null;
	
	return $path_to_dir;
}
 
function pan_uploader_get_file_mime($file) {
	
	$x = explode('.', $file);
    $extension = end($x);
	
	$mimes = array(
        'csv' => array('text/x-comma-separated-values', 'text/comma-separated-values', 'application/octet-stream', 'application/vnd.ms-excel', 'application/x-csv', 'text/x-csv', 'text/csv', 'application/csv', 'application/excel', 'application/vnd.msexcel', 'text/plain'),
        'exe' => array('application/octet-stream', 'application/x-msdownload'),
        'psd' => array('application/x-photoshop', 'image/vnd.adobe.photoshop'),
        'pdf' => array('application/pdf', 'application/force-download', 'application/x-download', 'binary/octet-stream'),
        'mif' => 'application/vnd.mif',
        'xls' => array('application/vnd.ms-excel', 'application/msexcel', 'application/x-msexcel', 'application/x-ms-excel', 'application/x-excel', 'application/x-dos_ms_excel', 'application/xls', 'application/x-xls', 'application/excel', 'application/download', 'application/vnd.ms-office', 'application/msword'),
        'ppt' => array('application/powerpoint', 'application/vnd.ms-powerpoint'),
        'pptx' => array('application/vnd.openxmlformats-officedocument.presentationml.presentation', 'application/x-zip', 'application/zip'),
        'wbxml' => 'application/wbxml',
        'gz' => 'application/x-gzip',
        'gzip' => 'application/x-gzip',
        'php' => array('application/x-httpd-php', 'application/php', 'application/x-php', 'text/php', 'text/x-php', 'application/x-httpd-php-source'),
        'php4' => 'application/x-httpd-php',
        'php3' => 'application/x-httpd-php',
        'phtml' => 'application/x-httpd-php',
        'phps' => 'application/x-httpd-php-source',
        'js' => array('application/x-javascript', 'text/plain'),
        'swf' => 'application/x-shockwave-flash',
        'sit' => 'application/x-stuffit',
        'tar' => 'application/x-tar',
        'tgz' => array('application/x-tar', 'application/x-gzip-compressed'),
        'xhtml' => 'application/xhtml+xml',
        'xht' => 'application/xhtml+xml',
        'zip' => array('application/zip', 'application/x-zip', 'application/x-zip-compressed',  'application/octet-stream', 'application/x-compress', 'application/x-compressed', 'multipart/x-zip'),
        'rar' => array('application/rar', 'application/x-rar', 'application/x-rar-compressed', 'application/octet-stream', 'application/x-compress', 'application/x-compressed', 'multipart/x-rar'),
        'mid' => 'audio/midi',
        'midi' => 'audio/midi',
        'mpga' => 'audio/mpeg',
        'mp2' => 'audio/mpeg',
        'mp3' => array('audio/mpeg', 'audio/mpg', 'audio/mpeg3', 'audio/mp3'),
        'aif' => array('audio/x-aiff', 'audio/aiff'),
        'aiff' => array('audio/x-aiff', 'audio/aiff'),
        'aifc' => 'audio/x-aiff',
        'ram' => 'audio/x-pn-realaudio',
        'rm' => 'audio/x-pn-realaudio',
        'rpm' => 'audio/x-pn-realaudio-plugin',
        'ra' => 'audio/x-realaudio',
        'rv' => 'video/vnd.rn-realvideo',
        'wav' => array('audio/x-wav', 'audio/wave', 'audio/wav'),
        'bmp' => array('image/bmp', 'image/x-windows-bmp'),
        'gif' => 'image/gif',
        'jpeg' => array('image/jpeg', 'image/pjpeg'),
        'jpg' => array('image/jpeg', 'image/pjpeg'),
        'jpe' => array('image/jpeg', 'image/pjpeg'),
        'png' => array('image/png', 'image/x-png'),
        'tiff' => 'image/tiff',
        'tif' => 'image/tiff',
        'css' => array('text/css', 'text/plain'),
        'html' => array('text/html', 'text/plain'),
        'htm' => array('text/html', 'text/plain'),
        'shtml' => array('text/html', 'text/plain'),
        'txt' => 'text/plain',
        'text' => 'text/plain',
        'log' => array('text/plain', 'text/x-log'),
        'rtx' => 'text/richtext',
        'rtf' => 'text/rtf',
        'xml' => array('application/xml', 'text/xml', 'text/plain'),
        'xsl' => array('application/xml', 'text/xsl', 'text/xml'),
        'mpeg' => 'video/mpeg',
        'mpg' => 'video/mpeg',
        'mpe' => 'video/mpeg',
        'qt' => 'video/quicktime',
        'mov' => 'video/quicktime',
        'avi' => array('video/x-msvideo', 'video/msvideo', 'video/avi', 'application/x-troff-msvideo'),
        'movie' => 'video/x-sgi-movie',
        'doc' => array('application/msword', 'application/vnd.ms-office'),
        'docx' => array('application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/zip', 'application/msword', 'application/x-zip'),
        'dot' => array('application/msword', 'application/vnd.ms-office'),
        'dotx' => array('application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/zip', 'application/msword'),
        'xlsx' => array('application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', 'application/zip', 'application/vnd.ms-excel', 'application/msword', 'application/x-zip'),
        'word' => array('application/msword', 'application/octet-stream'),
        'xl' => 'application/excel',
        'json' => array('application/json', 'text/json'),
        '3g2' => 'video/3gpp2',
        '3gp' => 'video/3gp',
        'mp4' => 'video/mp4',
        'm4a' => 'audio/x-m4a',
        'f4v' => 'video/mp4',
        'webm' => 'video/webm',
        'aac' => 'audio/x-acc',
        'm4u' => 'application/vnd.mpegurl',
        'm3u' => 'text/plain',
        'xspf' => 'application/xspf+xml',
        'vlc' => 'application/videolan',
        'wmv' => array('video/x-ms-wmv', 'video/x-ms-asf'),
        'au' => 'audio/x-au',
        'ac3' => 'audio/ac3',
        'flac' => 'audio/x-flac',
        'ogg' => 'audio/ogg',
        'kmz' => array('application/vnd.google-earth.kmz', 'application/zip', 'application/x-zip'),
        'kml' => array('application/vnd.google-earth.kml+xml', 'application/xml', 'text/xml'),
        'ics' => 'text/calendar',
        'zsh' => 'text/x-scriptzsh',
        '7zip' => array('application/x-compressed', 'application/x-zip-compressed', 'application/zip', 'multipart/x-zip'),
        'cdr' => array('application/cdr', 'application/coreldraw', 'application/x-cdr', 'application/x-coreldraw', 'image/cdr', 'image/x-cdr', 'zz-application/zz-winassoc-cdr'),
        'wma' => array('audio/x-ms-wma', 'video/x-ms-asf'),
        'jar' => array('application/java-archive', 'application/x-java-application', 'application/x-jar', 'application/x-compressed'),
        'ico' => array('image/x-ico', 'image/x-icon'),
    );
	
	($hook = get_hook('pan_uploader_fn_get_file_mime_new')) ? eval($hook) : null;
	
	if ( ! isset($mimes[$extension])) {
		$mime = 'application/octet-stream';
	} else {
		$mime = (is_array($mimes[$extension])) ? $mimes[$extension][0] : $mimes[$extension];
	}
	
	return $mime;
}

// Make a string safe to use in a URL
function pan_uploader_sef_friendly($str)
{
	global $forum_config, $forum_user;
	static $lang_url_replace, $forum_reserved_strings;

	if (!isset($lang_url_replace))
		require FORUM_ROOT.'lang/'.$forum_user['language'].'/url_replace.php';

	if (!isset($forum_reserved_strings))
	{
		// Bring in any reserved strings
		if (file_exists(FORUM_ROOT.'include/url/'.$forum_config['o_sef'].'/reserved_strings.php'))
			require FORUM_ROOT.'include/url/'.$forum_config['o_sef'].'/reserved_strings.php';
		else
			require FORUM_ROOT.'include/url/Default/reserved_strings.php';
	}

	$return = ($hook = get_hook('pan_uploader_fn_sef_friendly_start')) ? eval($hook) : null;
	if ($return != null)
		return $return;

	$str = strtr($str, $lang_url_replace);
	$str = strtolower(utf8_decode($str));
	$str = forum_trim(preg_replace(array('/[^a-z0-9\s]/', '/[\s]+/'), array('', '_'), $str), '_');

	foreach ($forum_reserved_strings as $match => $replace)
	{
		if ($str == $match)
			return $replace;
		else if ($match != '')
			$str = str_replace($match, $replace, $str);
	}
	return $str;
}

